#!/usr/bin/env ruby

# $Header: /cvsroot/umbrella/umbrella-devel/libumbrella/scripts/make_exec_key.rb,v 1.2 2005/03/17 13:56:19 sonoch Exp $

if not VERSION =~ /1\.8/
  puts "This script needs Ruby >=1.8"
  exit
end

trap(2) { puts "\nexiting ..."; exit 1 }


CODE="/tmp/keyinsert.c"

START_KEY_TAG="#umbkeystart#"
END_KEY_TAG="#umbkeyend#"

VENDOR_ID_SIZE = 64

class Arguments
  # set methods
  def set_id(id)
    @id = id
  end

  def set_file(file)
    @file = file
  end

  # get methods
  def get_id
    @id
  end

  def get_file
    @file
  end
end


def get_input argv
  arguments = Arguments.new
  argv.each { |input|
    if input =~ /^--id=/
      id = $'
      if not id =~ /^\w+$/
        puts "*** ERROR: Invalid ID. Only the characters A-Z, a-z, 0-9 and _ are allowed"
        puts "aborting ..."
        exit 1
      end
      arguments.set_id(id)
    elsif input =~ /^--key=/
      arguments.set_file($')
    else
      puts "Could not parse invalid argument: #{input}"
    end
  }
  
  if arguments.get_file == nil or arguments.get_id == nil
    puts "*** ERROR!"
    puts "aborting ..."
    exit 1
  end

    puts arguments.get_file, arguments.get_id

  return arguments
end

def pad_vendor_id vendor_id
  padding_size = VENDOR_ID_SIZE - vendor_id.length  

  padding = ""
  padding_size.times {
    padding = padding + ":"
  }
  
  final_id = vendor_id + padding

  return final_id
end


###### main 

arguments = get_input(ARGV)

BIN="./insert_#{arguments.get_id}_key"

f = File.open(CODE, "w")

f<<"int main() {"
f<<"  printf(\"Inserting key ... done\\n\");"
f<<"  return 0;"
f<<"}\n"

f.close()

`gcc -static -o #{BIN} #{CODE}`

File.delete(CODE)


string=""

string<<START_KEY_TAG
File.open(arguments.get_file, "r") { |f|
  f.each { |line|
    string<<line
  }
}
string<<END_KEY_TAG
string<<pad_vendor_id(arguments.get_id)
if File.size(arguments.get_file).to_s.length != 3
  puts "Error in size of key! - Expected size between 100-999 bytes!"
else
  string<<File.size(arguments.get_file).to_s 
end

f = File.open(BIN, "a")
string.each { |line|
  f << line
}
f.close

puts `sign_file.rb --id=master --file=#{BIN}`
