# Only source this file into your environment!
# Add the folowing line to your shell configuration file:
# source /usr/lib/libumbrella.sh

function rfork() {

	if [ -z "$1" ]; then
		echo Usage: rfork restrictions binary
		echo Example: rfork IPNET:BLUETOOTH:/tmp:/var/tmp /bin/sh
		return 1
	fi
	if [ -z "$2" ]; then
		echo Usage: rfork restrictions binary
		echo Example: rfork IPNET:BLUETOOTH:/tmp:/var/tmp /bin/sh
		return 1
	fi
	if [ -n "$3" ]; then
		echo Usage: rfork restrictions binary
		echo Example: rfork IPNET:BLUETOOTH:/tmp:/var/tmp /bin/sh
		return 1
	fi
	

	OIFS=$IFS
	IFS=:

	for r in $1; do
		case $r in
			KILL)      restr=$restr:1  ;;
			TERM)      restr=$restr:2  ;;
			QUIT)      restr=$restr:3  ;;
			HUP)       restr=$restr:4  ;;
			TRAP)      restr=$restr:5  ;;
			ALARM)     restr=$restr:6  ;;
			CHILD)     restr=$restr:7  ;;
			IPNET)     restr=$restr:8  ;;
			IRDA)      restr=$restr:9  ;;
			BLUETOOTH) restr=$restr:10 ;;
			FORK)      restr=$restr:11 ;;
			/)         restr=$restr:/  ;;
			*)		   restr=$restr:`echo $r | sed 's/\/$//'`;;
		esac
	done

	IFS=$OIFS

	# HACK to avoid noise in /proc (must be solved at some point!!!)
	restr=$restr:/evil/hack/that/should/be/avoided/.com

	tmp=`echo -n $restr| sed 's/ /:/g' | sed 's/^://'`
	echo ">>> executing $2 with restrictions $1"
	echo -n $tmp>/proc/umbrella

	$2

	unset restr
}

