#!/usr/bin/env ruby

if not VERSION =~ /1\.8/
  puts "This script needs Ruby >=1.8"
  exit
end

trap(2) { puts "\nexiting ..."; exit 1 }

if ARGV.length !=  2
  puts
  puts "Usage:   make-patch.rb <clean kernel tree> <umbrella kernel tree> "
  puts "Example: make-patch.rb  linux-2.6.3-clean   linux-2.6.3-umbrella"
  puts
  puts "Copyright (c) The Umbrella Team - http://umbrella.sourceforge.net"
  puts
  exit 1
end

clean = ARGV.at(0)
umbrella = ARGV.at(1)

if clean =~ /\// or umbrella =~ /\// 
  puts "You MUST be right in front of the two source trees => NO / characters allowed!"
  exit 1
end

puts
print "This will erase your .config - Continue? [Y/n] "
answer = STDIN.gets

if answer =~ /n/i
  exit 1
end

if answer =~ /(y|\n)/i
  puts "Making mr proper"
  puts `cd #{umbrella} && make mrproper && echo done || echo ERROR MAKING MR PROPER`

  puts "Removing cvs directories"
  puts `cd #{umbrella} && find . -type d -name CVS|xargs rm -fr && echo done || echo ERROR REMOVING CVS!`

  date=`date +%y%m%d_%H%M%S`.chomp
  puts "Stand by while creating patch file: #{`pwd`.chop}/umbrella_#{date}.patch"
  `diff -ruNBb #{clean} #{umbrella} > umbrella_#{date}.patch`

  puts "finished"

  exit 0
end


