#!/usr/bin/env ruby

if not VERSION =~ /1\.8/
  puts "This script needs Ruby >=1.8"
  exit
end

trap(2) { puts "\nexiting ..."; exit 1 }

if ARGV.length < 1 or ((ARGV.length < 2) and (ARGV.at(0) =~ /(^-s$|^--security_only$)/))
  puts
  puts "Usage:   merge-kernel.rb path/to/kernel_tree"
  puts "Example: merge-kernel.rb /home/umbrella/linux-2.6.11"
  puts
  puts "Copyright (c) The Umbrella Team - http://umbrella.sourceforge.net"
  puts
  exit 1
end

flag      = ARGV.at(0)
linux_dir = ARGV.at(0) if ARGV.length == 1 
linux_dir = ARGV.at(1) if ARGV.length == 2 

scripts_dir = $0.sub(/merge-kernel\.rb/, '')
umbrella_dir = scripts_dir + '../'
kernel_dir = umbrella_dir + 'kernel'
`mkdir -p #{linux_dir}/security/umbrella/include`
`mkdir -p #{linux_dir}/security/umbrella/mpi/generic`
`mkdir -p #{linux_dir}/security/umbrella/cipher`

if flag =~ /(^-s$|^--security_only$)/
  puts "The flags -s and --security_only is obsolete"
end


files=`cd #{kernel_dir} && find . -type f | grep -v CVS`

files.each { |f|
  f = f.chomp
  f = f.reverse.chop.chop.reverse
  a = f.split(/\//)
  if (a.reverse.at(0) =~ /^#/ or a.reverse.at(0) =~ /^\.#/ or a.reverse.at(0) =~ /~$/)
    #  puts "ignoring #{kernel_dir}/#{f}" 
    next
  end
	`rm -f #{linux_dir}/#{f}`
  puts ">>> #{linux_dir}/#{f}"
  `cp #{kernel_dir}/#{f} #{linux_dir}/#{f}`
}

puts "done"

exit 0
