#!/usr/bin/env bash

# $Header: /cvsroot/umbrella/umbrella-devel/test-kit/runtest.sh,v 1.1 2004/11/25 12:40:58 ipqw Exp $

function visual_sleep () {
let "i = 0"

while [ "$i" -lt "$1" ]; do
	echo -n "."
	sleep 1
	let "i = i + 1"
done
echo
}

LOGFILE=$PWD/test-kit.log

echo Log file available here: $LOGFILE
date >> $LOGFILE
echo Making 11 trees of nested processes ... >> $LOGFILE
echo Making 11 trees of nested processes ...

echo forking 1 process
echo forking 1 process >> $LOGFILE
./fork_test 1
echo forking 8 process
echo forking 8 process >> $LOGFILE
./fork_test 2
echo forking 24 process
echo forking 24 process >> $LOGFILE
./fork_test 3
echo forking 64 process
echo forking 64 process >> $LOGFILE
./fork_test 4
echo forking 160 process
echo forking 160 process >> $LOGFILE
./fork_test 5
echo forking 384 process
echo forking 384 process >> $LOGFILE
./fork_test 6
echo forking 896 process
echo forking 896 process >> $LOGFILE
./fork_test 7
echo forking 2048 process
echo forking 2048 process >> $LOGFILE
./fork_test 8
echo forking 4608 process
echo forking 4608 process >> $LOGFILE
./fork_test 9
echo forking 10240 process
echo forking 10240 process >> $LOGFILE
./fork_test 10

echo sleeping for 3 minutes to let the kernel clean the last run
visual_sleep 180
echo forking 22528 process
echo forking 22528 process >> $LOGFILE
used_before=`free|grep ^Mem|awk '{ print $3 }'`
./fork_test 11
echo sleeping for 3 minutes to let the kernel clean the last run
visual_sleep 180
used_after=`free|grep ^Mem|awk '{ print $3 }'`
let "difference = $used_after - $used_before"
echo "memory before: $used_before, after: $used_after, difference: $difference">> $LOGFILE
# if we lose more than 10 kb in the last run we show the warning
if [ "$difference" -gt 10 ]; then
	echo "WARNING: loosing $difference kb memory on last test!"
fi

echo Making 100 processes looping in background
echo Making 100 processes looping in background >> $LOGFILE
let "i = 0"
while [ "$i" -lt 100 ]; do
	./umbrella_daemon
	let "i = i + 1"
done

echo Killing all 100 daemons
echo Killing all 100 daemons >> $LOGFILE
pkill umbrella_daemon

